################################################################################
# Postgres95 Access֥                                                  #
################################################################################
# ᥾å
#  error
#  select
#  insert
#  update
#  exec
#  set_titles
#  get_info
package Pg_SQL;

use Pg;

%code2type = ('16'  ,'bool',
	      '17'  ,'bytea',
	      '18'  ,'char',
	      '19'  ,'name',
	      '20'  ,'char16',
	      '21'  ,'int2',
	      '22'  ,'int28',
	      '23'  ,'int4',
	      '25'  ,'text',
	      '409' ,'char2',
	      '410' ,'char4',
	      '411' ,'char8',
	      '700' ,'float4',
	      '701' ,'float8',
	      '702' ,'abstime',
	      '703' ,'reltime',
	      '1042','bpchar',
	      '1043','varchar',
	      '1082','date',
	      '1083','time'
	      );

# 󥹥ȥ饯
#    PQconn query
sub new {
    shift(@_);
    my $self = {};
    $self->{conn} = shift(@_);
    $self->{table} = shift(@_);
    my @fields = @_;
    $self->{fields} = \@fields;
    undef(@titles);
    $self->{error} = 0;

    my $pg = &select($self,"");
    my @ftypes = $pg->get_info('ftype');
    $self->{ftypes} = \@ftypes;

    bless $self;
}

# 顼ȯƤ뤫Ĵ٤롣
#    ʤ
#  顼(:0 顼:1)
sub error {
    my $self = shift(@_);
    return $self->{error};
}

# select queryμ¹
#    where,oder by
#  Pg_SQL_select֥
sub select {
    $self->{error} = 1;			# 顼ɤΥꥻå
    my $self = shift(@_);
    my $where = shift(@_);
    my @fields = @{$self->{fields}};
    my $query = "select " . join(',',@fields) . " from $self->{table} $where";
    if ($main::DEBUG) {print "$query\n";}
    $self->{error} = 0;			# 顼ɤͤ򥻥å
    return Pg_SQL_select->new($self->{conn},$query);
}

# insert queryμ¹
#    ǡ
#  顼
sub insert {
    $self->{error} = 1;			# 顼ɤΥꥻå
    my $self = shift(@_);
    my @values = &singlequote($self,@_);
    my @fields = @{$self->{fields}};

    my $query = "insert into $self->{table} (" . join(',',@fields) . ') values (' . join(',',@values) . ')';
    if ($main::DEBUG) {print "$query\n";}

    my $result = PQexec($self->{conn},$query);
    if ($result) {
	PQclear($result);
	$self->{error} = 0;			# 顼ɤͤ򥻥å
    }
}

# queryμ¹
#    where
#        ǡ
#  ʤ
sub update {
    $self->{error} = 1;			# 顼ɤΥꥻå
    my $self = shift(@_);
    my $where = shift(@_);
    my @values = &singlequote($self,@_);
    my @fields = @{$self->{fields}};

    my $query = "update $self->{table} set $fields[0] = $values[0]";
    for ($i=1;$i<=$#values;$i++) {
	$query .= ",$fields[$i] = $values[$i] "
    }
    $query .= $where;
    if ($main::DEBUG) {print "$query\n";}
    
    my $result = PQexec($self->{conn},$query);
    if ($result) {
	PQclear($result);
	$self->{error} = 0;			# 顼ɤͤ򥻥å
    }
}

# queryμ¹
#    SQLʸ
#  selectξϥ֥
sub exec {
    $self->{error} = 1;			# 顼ɤΥꥻå
    my $self = shift(@_);
    my $query = shift(@_);
    my @fields = @{$self->{fields}};
    if ($main::DEBUG) {print "$query\n";}

    if ($query =~ /^select/) {
	$self->{error} = 0;			# 顼ɤͤ򥻥å
	return Pg_SQL_select->new($self->{conn},$query);
    } else {
	my $result = PQexec($self->{conn},$query);
	if ($result) {
	    PQclear($result);
	    $self->{error} = 0;			# 顼ɤͤ򥻥å
	}
    }
}

# Υȥ򥻥åȤ롣
#    ȥ̾ä
#  ʤ
sub set_info {
    my $self = shift(@_);
    my $info_type = shift(@_);
    my @info = @_; 
   if ($info_type eq 'title') {
	$self->{titles} = \@info;
    } elsif ($info_type eq 'type') {
	$self->{types} = \@info;
    }
    $self->{error} = 0;
}

# ξФ
#    μ ('title')
#  Ф
sub get_info {
    my $self = shift(@_);
    $_ = shift(@_);
    my @info = ();

  SWITCH: {
      /title/ && do {
	  @info = @{$self->{titles}};
	  last SWITCH;
      };
      /type/ && do {
	  @info = @{$self->{types}};
	  last SWITCH;
      };
  }

    $self->{error} = 0;			# 顼ɤͤ򥻥å
    return @info;
}

# ǥȥ饯
sub DESTROY {

}

# 󥰥륯Ȥդ롣
sub singlequote {
    my $self = shift(@_);
    my @values = @_;

    my @ftype = @{$self->{ftypes}};

    for ($i=0;$i<=$#ftype;$i++) {
	if ($ftype[$i] =~ /^16$|^21$|^22$|^23$|^700$|^701$/) {
	    if ($values[$i] eq "") {$values[$i] = "NULL"}
	} else {
	    $values[$i] = "'" . $values[$i] . "'";
	}
    }
    return @values;
}

################################################################################
# selectʸѥ֥                                                     #
################################################################################
# ᥾å
#  error
#  get_line
#  get_nline
#  get_info
package Pg_SQL_select;

use Pg;

# select query¹Ԥ֥Ȥ롣
#    PQconn;
#        select query
sub new {
    shift(@_);
    my $conn = shift(@_);
    my $query = shift(@_);
    my $self = {};
    $self->{error} = 1;			# 顼ɤΥꥻå

    $self->{result} = PQexec($conn,$query);
    if ($self->{result}) {
	$self->{ntuples} = PQntuples($self->{result});
	$self->{nfields} = PQnfields($self->{result});
	$self->{now_line} = 0;
	$self->{error} = 0;			# 顼ɤͤ򥻥å
    }
    bless $self;
}

# 顼ȯƤ뤫Ĵ٤롣
#    ʤ
#  顼(:0 顼:1)
sub error {
    my $self = shift(@_);
    return $self->{error};
}

# ԤĥǡФ֤
#   ʤ
#  ʬΥǡ
sub get_line {
    my $self = shift(@_);
    $self->{error} = 1;			# 顼ɤΥꥻå
    if ($self->{now_line} >= $self->{ntuples}) {return ();}
    return  &get_nline($self,$self->{now_line}++);
}

# ꤵ줿ԤΥǡФ֤
#   row
#  ʬΥǡ
sub get_nline {
    my $self = shift(@_);
    my $lines = shift(@_);
    $self->{error} = 1;			# 顼ɤΥꥻå
    if ($lines >= $self->{ntuples}) {return ();}
    my @line = ();
    for ($i=0;$i<$self->{nfields};$i++) {
	$line[$i] = PQgetvalue($self->{result},$lines,$i);
	$line[$i] =~ s/(\s*)$//g;
    }
    $self->{error} = 0;			# 顼ɤͤ򥻥å
    return @line;
}

# ԤĥǡФϢ֤
#   ʤ
#  ʬΥǡ
sub get_line_assoc_array {
    my $self = shift(@_);
    $self->{error} = 1;			# 顼ɤΥꥻå
    if ($self->{now_line} >= $self->{ntuples}) {return ();}
    return &get_nline_assoc_array($self,$self->{now_line}++);
}

# ꤵ줿ԤΥǡФϢ֤
#   row
#  ʬΥǡ
sub get_nline_assoc_array {
    my $self = shift(@_);
    my $lines = shift(@_);
    $self->{error} = 1;			# 顼ɤΥꥻå
    if ($lines >= $self->{ntuples}) {return ();}
    my %line = ();
    my $fname;
    for ($i=0;$i<$self->{nfields};$i++) {
	$fname = PQfname($self->{result},$i);
	$line{$fname} = PQgetvalue($self->{result},$lines,$i);
	$line{$fname} =~ s/(\s*)$//g;
    }
    $self->{error} = 0;			# 顼ɤͤ򥻥å
    return %line;
}

# ξФ
#    μ ('fname' ftype' 'fsize')
#  Ф
sub get_info {
    my $self = shift(@_);
    my $infotype = shift(@_);
    my @line = ();
    for ($i=0;$i<$self->{nfields};$i++) {
	if ($infotype eq 'fname') {
	    $line[$i] = PQfname($self->{result},$i);
	}
	if ($infotype eq 'ftype') {
	    $line[$i] = PQftype($self->{result},$i);
	}
	if ($infotype eq 'fsize') {
	    $line[$i] = PQfsize($self->{result},$i);
	}
    }
    $self->{error} = 0;			# 顼ɤͤ򥻥å
    return @line;
}

# ǥȥ饯
sub DESTROY {
    my $self = shift(@_);
    if ($main::DEBUG) {print "clean!!\n";}
    PQclear($self->{result});
}

1;
